const test = require('tape')
    , fs   = require('fs')
    , path = require('path')
    , wasm = require('./')


var testDir = path.join(__dirname, 'test-data')
  , files   = fs.readdirSync(testDir)
  , jsFiles = files.filter(function (f) { return /\.js$/.test(f) })

jsFiles.forEach(function (file) {
  var name = file.replace(/\.js$/, '')
  test('test ' + name, function (t) {
    var wasmData  = fs.readFileSync(path.join(testDir, name + '.wasm'))
    var asmjsData = fs.readFileSync(path.join(testDir, name + '.js'), 'utf8')
    var wasmToAsm = wasm(null, wasmData)

    t.equal(asmjsData, wasmToAsm)

    var fn = new Function(wasmToAsm)
    t.end()
  })
})